﻿WoWUnitConsole = {};

function WoWUnitConsole:Print(text, red, green, blue)
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFF8040WoWUnit: |r" .. (text or ""), red, green, blue)
end

function WoWUnitConsole:SlashCommand(args)
	if args == "" then
		self:Print("WoWUnit", 1, 1, 0);
	
		self:Print("   usage: /wowunit <test suite> or /wu <test suite>");
		self:Print("Test Suites:", 1, 1, 0);
		
		local suites = WoWUnit:GetTestSuites();
		local sorted = {};
		
		for k, _ in pairs(suites) do
			table.insert(sorted, k);
		end
		
		table.sort(sorted);
		
		for _, v in ipairs(sorted) do
			self:Print("   " .. v);
		end
	else
		if WoWUnit:QueueTestSuite(args) then
			self:Print("Running " .. WoWUnit:GetRemainingTestCount() .. " tests from suite " .. args .. "...");
		else
			self:Print("No test suite name |cFFFF0000" .. (args or "(nil)") .. " has been registered.");
		end
	end
end

function WoWUnitConsole:PrintTestResults()
	local testCount = 0;
	local passCount = 0;
	
	local result = WoWUnit:GetFirstResult();
	while result do
		testCount = testCount + 1;
		if result.pass == true then
			passCount = passCount + 1;
		else
			self:Print("|cFFFF0000FAILED|r: |cFFFFFF00" .. (result.suite or "(suite)") .. ":" .. (result.test or "(untitled)") .. "|r");
			if result.message then
				self:Print("    |cFFFFAA00" .. result.message .. "|r");
			end
		end
		result = result.next;
	end
	
	self:Print("|cFF00AA00Passed " .. passCount .. " of " .. testCount .. " tests.|r");
end

SLASH_WOWUNIT1 = "/wowunit";
SLASH_WOWUNIT2 = "/wu";

SlashCmdList["WOWUNIT"] = function(args) WoWUnitConsole:SlashCommand(args) end;